#include <stdio.h>

extern struct rtpkt {
  int sourceid;       /* id of sending router sending this pkt */
  int destid;         /* id of router to which pkt being sent 
                         (must be an immediate neighbor) */
  int mincost[4];    /* min cost to node 0 ... 3 */
  };

extern int TRACE;
extern int YES;
extern int NO;

struct distance_table 
{
  int costs[4][4];
} dt2;


int connectcosts2[4] = { 3,  1,  0, 2 };

// caminhos minimos
int mincost2[4];

int noway2=4;
int myself2 = 2;
	
/* students to write the following two routines, and maybe some others */

void rtinit2() 
{
	int i,j;

	struct rtpkt packet;

				
	for (i=0; i<4; i++)
		for (j=0; j<4; j++)
		{
			if (j== noway2 || i == noway2)
				dt2.costs[i][j] = connectcosts2[noway2];		// no sei o caminho
			else
			{
				if (j == myself2)
					dt2.costs[i][j]= connectcosts2[i];
				else if (i == myself2)
					dt2.costs[i][j]= 2 * connectcosts2[j];
				else if (i == j)
					dt2.costs[i][j] = connectcosts2[i];	// link direto
				else 
					dt2.costs[i][j] = connectcosts2[j]* 2 + connectcosts2[i]; // vou para j, volto para 1, e vou para i (i atraves de j)
			}
		}
	
	if (TRACE>1)
	{	printf("\nTabela de distancias inicial do n %d:\n", myself2);			
		printdt2(&dt2);
	}

	// acha os caminhos minimos
	for(j=0;j<4;j++)
		mincost2[j] = dt2.costs[j][j];
		
	// envia os caminhos minimos para os vizinhos;
	for (i=0; i<4; i++)
		if (i!= myself2 && i!= noway2)
		{
			packet.destid = i;
			packet.sourceid= myself2;
			for(j=0;j<4;j++) 
				packet.mincost[j] = mincost2[j];

			tolayer2(packet);
		}
		
}


void rtupdate2(rcvdpkt)
  struct rtpkt *rcvdpkt;
  
{
	int change = 0;
	int i, j;
	struct rtpkt packet;
	
	j = rcvdpkt->sourceid;
	
	for(i=0; i<4; i++)
	{
		// se o caminho at J + o caminho at I for menor que o meu caminho minimo at I, atualiza a tabela
		if(mincost2[j] + rcvdpkt->mincost[i] < mincost2[i])
		{
			// atualiza os caminhos minimos
			mincost2[i] = mincost2[j] + rcvdpkt->mincost[i];
			// atualiza a tabela de distancia. Para ir at I atraves de J
			dt2.costs[i][j] = mincost2[i];
			change = 1;
		}
	}

		
	if (change)
	{
		if (TRACE>1)
		{	printf("\nTabela de distancias atualizada %d:\n", myself2);			
			printdt2(&dt2);
		}	
		for (i=0; i<4; i++)
			if (i!= myself2 && i!= noway2)
			{
				packet.destid = i;
				packet.sourceid= myself2;
				for(j=0;j<4;j++) 
					packet.mincost[j] = mincost2[j];
				tolayer2(packet);
			}
	}
	
}


printdt2(dtptr)
  struct distance_table *dtptr;
  
{
  printf("                via     \n");
  printf("   D2 |    0     1    3 \n");
  printf("  ----|-----------------\n");
  printf("     0|  %3d   %3d   %3d\n",dtptr->costs[0][0],
	 dtptr->costs[0][1],dtptr->costs[0][3]);
  printf("dest 1|  %3d   %3d   %3d\n",dtptr->costs[1][0],
	 dtptr->costs[1][1],dtptr->costs[1][3]);
  printf("     3|  %3d   %3d   %3d\n",dtptr->costs[3][0],
	 dtptr->costs[3][1],dtptr->costs[3][3]);
}







